---
title: Step through code
slug: Tools/Debugger/How_to/Step_through_code
tags:
  - Debugger
  - DevTools
  - JavaScript
  - Step through code
---
<div>{{ToolsSidebar}}</div>

<p>When the debugger is stopped at a breakpoint, you can step through it using four buttons in the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Toolbar">toolbar</a>:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16431/breakpoint_toolbar.png" style="display: block; height: 220px; margin-left: auto; margin-right: auto; width: 600px;"></p>

<p>In order, the buttons are:</p>

<ul>
 <li>Play: run to the next breakpoint</li>
 <li>Step over: advance to the next line in the same function.</li>
 <li>Step in: advance to the next line in the function, unless on a function call, in which case enter the function being called</li>
 <li>Step out: run to the end of the current function, in which case, the debugger will skip the return value from a function, returning execution to the caller</li>
</ul>

<p>{{EmbedYouTube("RQBwEk0-xe0")}}</p>

<h2 id="Split_console">Split console</h2>

<p>When paused, you can press the Esc key to open and close the split console to gain more insight into errors and variables:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16432/split_console.png" style="border: 1px solid black; display: block; height: 283px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<h2 id="Pause_on_breakpoints_overlay">Pause on breakpoints overlay</h2>

<p>Since Firefox 70, when your code is paused on a breakpoint an overlay appears on the viewport of the tab you are debugging.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16996/debugger-overlay.png" style="border-style: solid; border-width: 1px; height: 603px; width: 1000px;"></p>

<p>This lets you know what kind of breakpoint the code is paused on (breakpoint, event breakpoint, etc.), and also provides a step button and a play button. The thinking here is that if you've got your DevTools open in a separate window, as many people do, it can be easier to have the buttons available right there to move the code forward while you are looking at the result.</p>

<p>If you want to turn this feature off, since Firefox 71 you can do so by going to <code>about:config</code> in a new tab, setting the <code>devtools.debugger.features.overlay</code> pref to <code>false</code>, and restarting the browser.</p>

<h2 id="Inline_variable_preview">Inline variable preview</h2>

<p>New in Firefox 71, the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_pane">source pane</a> now gives you an instant preview of the variables on each line of code you've stepped through. See <a href="/en-US/docs/Tools/Debugger/How_to/Set_a_breakpoint#Inline_variable_preview">Set a breakpoint &gt; Inline variable preview</a> for more information.</p>
